/*
21-04-2014
MikroC Pro 6.0
test Ready for Pic card with 18F45K22
avec COG16 enfich sur PortB
et liaison USB (alimente la carte)

Vbray sur COM12 19200,N,8,1
via FTDI driver

 10/02/2012
 * Project name:
     test cog  2x16 lcd board        ac:COG
 * Description:
     This code demonstrates how to use Lcd 4-bit library with COG 2x16 LCD Board.
 * Test configuration:
     mcu:             pic18f45k22   with bootloader via USB
     Dev.Board:       Ready For Pic Box version rev 1.12     ac:Ready_for_PIC
     Oscillator:      HS, Quartz 8Mhz PLLx4 => 32.0000 MHz
     
     Configuration  : P18F45K22.cfgsch
CONFIG1H   :$300001 : 0x0033
CONFIG2L   :$300002 : 0x001F
CONFIG2H   :$300003 : 0x003C
CONFIG3H   :$300005 : 0x00BD
CONFIG4L   :$300006 : 0x0081
CONFIG5L   :$300008 : 0x000F
CONFIG5H   :$300009 : 0x00C0
CONFIG6L   :$30000A : 0x000F
CONFIG6H   :$30000B : 0x00E0
     
     Ext. Modules:    COG 2x16 LCD Board on PORTB
     SW:              mikroC PRO 5.40 for PIC
 * NOTES:
     None.
*/

#define TAB 9
#define CLS 12

// LCD module connections
sbit LCD_RS at LATB2_bit;
sbit LCD_EN at LATB3_bit;
sbit LCD_D4 at LATB4_bit;
sbit LCD_D5 at LATB5_bit;
sbit LCD_D6 at LATB6_bit;
sbit LCD_D7 at LATB7_bit;

sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;
// End LCD module connections
            //1234567890123456
char IntValue[12];
char txt1[] = "18F45K22 Ready  ";
char txt2[] = "for PIC BootLoad";
char txt3[] = "COG  2x16 board ";
char txt4[] = "Mesures";
int i,j,k;                              // Loop variable
unsigned int temp_res;

void CRLF()
{
 UART1_Write(13);
  UART1_Write(10);
}

void main(){
  ANSELB  = 0;                        // Configure AN pins as digital I/O
  ANSELA=2;   // RA1 as analog
  C1ON_bit = 0;               // Disable comparators
  C2ON_bit = 0;

  TRISB=0x00 ; // all outputs
  TRISA=0b11101111 ; // RA4 as output
  TRISC=0b10111101 ; //RC1 as output
  UART1_Init(19200);  // Initalize USART (38400,8,N,1)
  // Select Vref and analog inputs, in order to use ADC_Read
  ADCON0 = 0x02;     // All porta pins as analog, VDD as Vref
  ADCON1 = 0 ; // refences sur +3,3V et Ground
  ADCON2.ADFM=1 ;          // right justified
  ADCON2.ACQT2 = 1;        // 8 TAD
  ADCON2.ACQT1 = 0;
  ADCON2.ACQT0 = 0;
  ADCON2.ADCS2= 0;         // FOsc/32
  ADCON2.ADCS1= 1;
  ADCON2.ADCS0= 0;
  while (UART1_Tx_Idle() == 0) ;
  UART1_Write(CLS);
  delay_ms(500);
  UART1_Write_Text("Pic18F45K22 et COG16 LCD \r\n");
  ADC_Init();

  Lcd_Init();                        // Initialize LCD
  Delay_ms(100);

  Lcd_Cmd(_LCD_CLEAR);               // Clear display
  Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
  Lcd_Out(1,1,txt1);                 // Write text in first row
  Lcd_Out(2,1,txt2);                 // Write text in second row
  Delay_ms(4000);
   UART1_Write_Text("Let's go for ADC measure \r\n");
   Lcd_Cmd(_LCD_CLEAR);               // Clear display
   Lcd_Out(1,1,txt3);                 // Write text in first row
   Delay_ms(1000);
   j=0;
    Lcd_Cmd(_LCD_CLEAR);
   do
  {

    Lcd_Out(1,1,txt4);
    WordToStr(j,IntValue);
    UART1_Write_Text(IntValue);UART1_Write(TAB);
    Lcd_Out(1,8,IntValue);

   // Read ADC 0 and send result via UART1
   temp_res = ADC_Read(1) ;
   WordToStr(temp_res,IntValue);
   UART1_Write_Text(IntValue);UART1_Write(TAB);
   temp_res= ADC_Get_Sample(2);
   WordToStr(temp_res,IntValue);
   UART1_Write_Text(IntValue);
   Lcd_Out(2,1,IntValue);                 // Write ADC value
    Delay_ms(500);
    if (PORTA.RA4==1) PORTA.RA4=0; else PORTA.RA4=1;  // clignote led PORTA
    CRLF();
    j++;
  } while (1);       // end main loop
}

/*
0 1 mikroCPIC1618.exe -MSF -DBG -pP18F45K22 -DL -O11111015 -fo32 -N"
C:\_MickroC\_MesProjets_MickroC\_18F45K22_ReadyForPic\18F45K22_LCD_COG.mcppi" -SP"
C:\Program Files\Mikroelektronika\mikroC PRO for PIC\defs\" -SP"
C:\Program Files\Mikroelektronika\mikroC PRO for PIC\uses\P18\" -SP"
C:\_MickroC\_MesProjets_MickroC\_18F45K22_ReadyForPic\" -SP"
C:\_MickroC\defs\" -SP"C:\_MickroC\uses\P18\" -SP"
C:\_MickroC\_MesProjets_MickroC\common\" -SP"
E:\_MikroElektronika\" "18F45K22_test_COG_140421.c" 
__Lib_Math.mcl" "
__Lib_MathDouble.mcl" "
__Lib_System.mcl" "
__Lib_Delays.mcl" "
__Lib_CString.mcl" "
__Lib_Conversions.mcl" "
__Lib_ADC_A_D.mcl" "
__Lib_UART_c67d67.mcl" "
__Lib_LcdConsts.mcl" "
__Lib_Lcd.mcl"

0 1501 Specified search path does not exist: 'C:\_MickroC\defs'  
0 1501 Specified search path does not exist: 'C:\_MickroC\uses\P18'  
0 1139 Available RAM: 1515 [bytes], Available ROM: 32768 [bytes]  
0 126 All files Preprocessed in 47 ms  
0 122 Compilation Started 18F45K22_test_COG_140421.c
132 123 Compiled Successfully 18F45K22_test_COG_140421.c
0 127 All files Compiled in 156 ms  
0 1144 Used RAM (bytes): 160 (11%)  Free RAM (bytes): 1355 (89%) Used RAM (bytes): 160 (11%)  Free RAM (bytes): 1355 (89%)
0 1144 Used ROM (bytes): 1689 (5%)  Free ROM (bytes): 31079 (95%) Used ROM (bytes): 1689 (5%)  Free ROM (bytes): 31079 (95%)
0 125 Project Linked Successfully 18F45K22_LCD_COG.mcppi
0 128 Linked in 141 ms  
0 129 Project '18F45K22_LCD_COG.mcppi' completed: 453 ms  
0 103 Finished successfully: 21 avr. 2014, 17:24:03 18F45K22_LCD_COG.mcppi

/*
MikroBootloader @115200Bauds sur COM6
C:\_MickroC\_MesProjets_MickroC\_18F45K22_ReadyForPic\18F45K22_LCD_COG.hex
Waiting MCU response...
Connected.
Opened: C:\_MickroC\_MesProjets_MickroC\_18F45K22_ReadyForPic\18F45K22_LCD_COG.hex
Uploading...
Finishing...
Completed successfully.
Disconnected.
*/
/*
Resultat sur COM12 Vbray
17:34:11.921> Pic18F26K20 et COG16 LCD 
17:34:16.109> Let's go for ADC measure 
17:34:17.671>     0          983          983
17:34:18.171>     1          784          784
17:34:18.671>     2          606          606
17:34:19.234>     3          530          530
17:34:19.734>     4          465          465
17:34:20.296>     5          414          414
17:34:20.796>     6          378          378
17:34:21.296>     7          371          371
17:34:21.859>     8          355          355
17:34:22.359>     9          370          370
17:34:22.921>    10          351          351
17:34:23.421>    11          337          337
17:34:23.984>    12          403          403
   */